CREATE OR REPLACE VIEW V_KUPCI_SALDAKONTI AS (
SELECT CONCAT(CONCAT(K.ID, CASE WHEN N.ID IS NULL THEN '' ELSE '-' END), N.ID) AS V_KUPCI_SALDAKONTI_ID, K.ID AS KUPCI_ID, N.ID AS NNFIRMA_ID, N.FIRMA AS NNFIRMA_FIRMA, K.VALUTA_PLACILA,
  (CASE WHEN K.VALUTA_PLACILA IS NULL OR K.VALUTA_PLACILA = (SELECT DOMACAVALUTA FROM PARAM) THEN 'Y' ELSE 'N' END) AS KUPCI_DOMACA_VALUTA, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK,
  
  -- Odprte navadne storitve, domaca valuta
  (
    SELECT SUM(COALESCE(M.ZNESEK, 0) * (1-COALESCE(M.POPUST, 0)/100) * (1-COALESCE(M.POPUST1, 0)/100) * (1-COALESCE(M.POPUST2, 0)/100) * (1-COALESCE(M.PROVIZIJA, 0)/100)* (1+COALESCE(M.DAVEK, 0)/100)) 
    FROM M_STORITVE M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) 
    AND (M.VALUTA IS NULL OR M.VALUTA = (SELECT DOMACAVALUTA FROM PARAM)) AND M.N_RACUNA IS NULL AND UPPER(M.VRSTA) = 'ST'
  ) AS OPEN_REGULAR_SERVICES_SIT,
  
  -- Odprte navadne storitve, tuja valuta
  (
    SELECT SUM(COALESCE(M.ZNESEK, 0) * (1-COALESCE(M.POPUST, 0)/100) * (1-COALESCE(M.POPUST1, 0)/100) * (1-COALESCE(M.POPUST2, 0)/100) * (1-COALESCE(M.PROVIZIJA, 0)/100)* (1+COALESCE(M.DAVEK, 0)/100)) 
    FROM M_STORITVE M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) 
    AND M.VALUTA = K.VALUTA_PLACILA AND M.N_RACUNA IS NULL AND UPPER(M.VRSTA) = 'ST'
  ) AS OPEN_REGULAR_SERVICES_DEM,
  
    -- Odprte pogodbene storitve, domaca valuta
  (
    SELECT SUM(COALESCE(M.ZNESEK, 0) * (1-COALESCE(M.POPUST, 0)/100) * (1-COALESCE(M.POPUST1, 0)/100) * (1-COALESCE(M.POPUST2, 0)/100) * (1-COALESCE(M.PROVIZIJA, 0)/100)* (1+COALESCE(M.DAVEK, 0)/100)) 
    FROM M_STORITVE M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) 
    AND (M.VALUTA IS NULL OR M.VALUTA = (SELECT DOMACAVALUTA FROM PARAM)) AND M.N_RACUNA IS NULL AND UPPER(M.VRSTA) = 'PO'
  ) AS OPEN_CONTRACT_SERVICES_SIT,
  
  -- Odprte pogodbene storitve, tuja valuta
  (
    SELECT SUM(COALESCE(M.ZNESEK, 0) * (1-COALESCE(M.POPUST, 0)/100) * (1-COALESCE(M.POPUST1, 0)/100) * (1-COALESCE(M.POPUST2, 0)/100) * (1-COALESCE(M.PROVIZIJA, 0)/100)* (1+COALESCE(M.DAVEK, 0)/100)) 
    FROM M_STORITVE M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) 
    AND M.VALUTA = K.VALUTA_PLACILA AND M.N_RACUNA IS NULL AND UPPER(M.VRSTA) = 'PO'
  ) AS OPEN_CONTRACT_SERVICES_DEM,
  
  -- Odprti delovni nalogi, domaca valuta
   (
    SELECT SUM(M.SKUPAJ)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND UPPER(M.STATUS) = 'O'
  ) AS OPEN_WORK_ORDERS_SIT,
  
  -- Odprti delovni nalogi, tuja valuta
   (
    SELECT SUM(M.SKUPAJ_VAL)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND UPPER(M.STATUS) = 'O'
  ) AS OPEN_WORK_ORDERS_DEM,
  
  -- Nefakturirani delovni nalogi, domaca valuta
   (
    SELECT SUM(M.SKUPAJ)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND UPPER(M.STATUS) = 'N'
  ) AS UNINVOICED_WORK_ORDERS_SIT,
  
  -- Nefakturirani delovni nalogi, tuja valuta
   (
    SELECT SUM(M.SKUPAJ_VAL)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND UPPER(M.STATUS) = 'N'
  ) AS UNINVOICED_WORK_ORDERS_DEM,
  
  -- Parcialne ponudbe, domaca valuta
  (
    SELECT SUM(M.OPEN_AMOUNT)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND UPPER(M.STATUS) = 'P' AND M.CONFIRMED = 'Y'
  ) AS SALDAKONTI_PART_PROFORMA_SIT,
  
   -- Parcialne ponudbe, tuja valuta (skupajVal*openAmount/skupaj)
  (
    (SELECT COALESCE(SUM(M.SKUPAJ_VAL), 0)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND UPPER(M.STATUS) = 'P' AND M.CONFIRMED = 'Y') 
    * (SELECT COALESCE(SUM(M.OPEN_AMOUNT), 0)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND UPPER(M.STATUS) = 'P' AND M.CONFIRMED = 'Y')
    / (SELECT CASE WHEN (COALESCE(SUM(M.SKUPAJ), 0) = 0) THEN 1 ELSE SUM(M.SKUPAJ) END
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND UPPER(M.STATUS) = 'P' AND M.CONFIRMED = 'Y')
  ) AS SALDAKONTI_PART_PROFORMA_DEM,
  
  -- Ponudbe, domaca valuta
  (
    SELECT SUM(M.SKUPAJ)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND UPPER(M.STATUS) = 'P'
  ) AS SALDAKONTI_PROFORMA_SIT,
  
  -- Ponudbe, tuja valuta
  (
    SELECT SUM(M.SKUPAJ_VAL)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND UPPER(M.STATUS) = 'P'
  ) AS SALDAKONTI_PROFORMA_DEM,
  
  -- Saldo, domaca valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0')
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0')
  ) AS SALDAKONTI_SIT,
  
  -- Saldo brez depozitov, domaca valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0'
    AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    )
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0'
    AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    )
  ) AS SALDAKONTI_SIT_NO_DEPOSIT,
  
  -- Saldo, tuja valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = K.VALUTA_PLACILA AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0')
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = K.VALUTA_PLACILA AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0')
  ) AS SALDAKONTI_DEM,
  
  -- Saldo brez depozitov, tuja valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = K.VALUTA_PLACILA AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0'
    AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN = K.VALUTA_PLACILA AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    ) 
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = K.VALUTA_PLACILA AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0'
    AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN = K.VALUTA_PLACILA AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    ) 
  ) AS SALDAKONTI_DEM_NO_DEPOSIT,
  
  -- Saldo odprti, domaca valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
  ) AS SALDAKONTI_OUTSTANDING_SIT,
  
  -- Saldo odprti brez depozitov, domaca valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE)
     AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    )
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE)
      AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    )
  ) AS SALDAKONTI_OUT_SIT_NO_DEPOSIT, 
  
  -- Saldo odprti, tuja valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = K.VALUTA_PLACILA AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = K.VALUTA_PLACILA AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
  ) AS SALDAKONTI_OUTSTANDING_DEM,
  
  -- Saldo odprti brez depozitov, tuja valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = K.VALUTA_PLACILA AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE)
    AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN = K.VALUTA_PLACILA AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    ) 
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = K.VALUTA_PLACILA AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE)
    AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN = K.VALUTA_PLACILA AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    ) 
  ) AS SALDAKONTI_OUT_DEM_NO_DEPOSIT,
  
  -- Saldo prejeti, domaca valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'P' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0')
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'P' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0')
    
  ) AS SALDAKONTI_RECEIVED_SIT,
  
  -- Saldo prejeti, tuja valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = K.VALUTA_PLACILA AND UPPER(S.SDK_RN_TIP) = 'P' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0')
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = K.VALUTA_PLACILA AND UPPER(S.SDK_RN_TIP) = 'P' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0')
    
  ) AS SALDAKONTI_RECEIVED_DEM,
  
  -- Depoziti, domaca valuta
  (
    SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
      AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM) <= TRUNC(SYSDATE)
      AND S.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
  ) DEPOSIT_SIT,
  
  -- Depoziti, tuja valuta
  (
    SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
      AND S.VALUTA_RN = K.VALUTA_PLACILA AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM) <= TRUNC(SYSDATE)
      AND S.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
  ) DEPOSIT_DEM

FROM KUPCI K, V_NNFIRMA_ID_OR_NULL N
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1325, SYSDATE, '5.5', 1245, 'V_KUPCI_SALDAKONTI')
;