CREATE OR REPLACE VIEW V_NNPRIKLJ AS (
SELECT NN.NNPRIKLJ_ID, NN.ID_PRIVEZ, NN.OZNAKA, NN.PRIKLJ, NN.ZACETNO_STANJE, NN.KONCNO_STANJE, NN.ZASEDEN, NN.INTERNI_OPIS, NN.OPIS, NN.EXT_DATE AS NNPRIKLJ_EXT_DATE, NN.EXT_PONTOON, NN.EXT_SOCKET, 
NN.VOLTAGE, NN.AMPERAGE, NN.EUUS, NN.METER_HW_VALUE,
N.OPIS AS NPRIKLJ_OPIS, N.INTERNI_OPIS AS NPRIKLJ_INTERNI_OPIS, N.STORITEV AS NPRIKLJ_STORITEV, N.NPRIKLJ_TYPE AS NPRIKLJ_TYPE,
P.ID_PRIKLJ AS PRIKLJ_ID_PRIKLJ, P.ID_LASTNIKA AS PRIKLJ_ID_LASTNIKA, P.ID_PLOVILA AS PRIKLJ_ID_PLOVILA, P.ID AS PRIKLJ_ID, P.ID_STORITVE AS PRIKLJ_ID_STORITVE, P.OZNAKA AS PRIKLJ_OZNAKA, 
P.PRIKLJUCEK AS PRIKLJ_PRIKLJUCEK, P.DATUM_ZACETKA AS PRIKLJ_DATUM_ZACETKA, P.DATUM_KONCA AS PRIKLJ_DATUM_KONCA, P.ZACETNO_STANJE AS PRIKLJ_ZACETNO_STANJE, P.KONCNO_STANJE AS PRIKLJ_KONCNO_STANJE, 
P.ZASEDEN AS PRIKLJ_ZASEDEN, P.OBRACUNAN AS PRIKLJ_OBRACUNAN, P.STEVEC_HW_STANJE AS PRIKLJ_STEVEC_HW_STANJE,
NNP.OBJEKT AS NNPRIVEZ_OBJEKT, NNP.N_PRIVEZA AS NNPRIVEZ_N_PRIVEZA, NNP.KATEGORIJA AS NNPRIVEZ_KATEGORIJA, NNP.SORT_PRIKAZ AS NNPRIVEZ_SORT_PRIKAZ,
K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, PL.IME AS PLOVILA_IME, VPL.NNLOCATION_ID, VOL.OPIS AS VOLTAGE_OPIS, AMP.OPIS AS AMPERAGE_OPIS, EUS.OPIS AS EUUS_OPIS
FROM NNPRIKLJ NN
JOIN (SELECT NNI.NNPRIKLJ_ID, CASE WHEN (NNI.ZASEDEN = 'Y') THEN (SELECT MAX(PI.ID_PRIKLJ) FROM PRIKLJ PI WHERE PI.OZNAKA=NNI.OZNAKA AND PI.PRIKLJUCEK=NNI.PRIKLJ) ELSE NULL END AS PRIKLJ_ID FROM NNPRIKLJ NNI) NNI ON NNI.NNPRIKLJ_ID = NN.NNPRIKLJ_ID 
LEFT OUTER JOIN NPRIKLJ N ON NN.OZNAKA=N.SIFRA
LEFT OUTER JOIN NNPRIVEZ NNP ON NNP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN PRIKLJ P ON P.ID_PRIKLJ = NNI.PRIKLJ_ID
LEFT OUTER JOIN KUPCI K ON P.ID_LASTNIKA = K.ID
LEFT OUTER JOIN PLOVILA PL ON P.ID_PLOVILA = PL.ID
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPL ON VPL.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN NN_VOLTAGE VOL ON VOL.ID = NN.VOLTAGE
LEFT OUTER JOIN NN_AMPERAGE AMP ON AMP.ID = NN.AMPERAGE
LEFT OUTER JOIN NN_EUUS EUS ON EUS.ID = NN.EUUS
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1337, SYSDATE, '5.5', 1257, 'VNnpriklj meterHwValue')
;