DROP VIEW V_BERTH_OWNER;

CREATE OR REPLACE VIEW V_BERTH_OWNER AS (
SELECT BO.ID, BO.ID_PRIVEZ, BO.ID_LASTNIKA, BO.DATE_FROM, BO.DATE_TO, BO.DATE_CREATED, BO.USER_CREATED, BO.DATE_CHANGED, BO.USER_CHANGED, BO.STATUS, BO."COMMENT", BO.TYPE,
BOT.OPIS AS BERTH_OWNER_TYPE_OPIS, BOT.INTERNI_OPIS AS BERTH_OWNER_TYPE_INTERNI_OPIS, 
NP.OBJEKT AS NNPRIVEZ_OBJEKT, NP.N_PRIVEZA AS NNPRIVEZ_N_PRIVEZA, NP.DOLZINA AS NNPRIVEZ_DOLZINA, NP.SIRINA AS NNPRIVEZ_SIRINA, NP.SORT AS NNPRIVEZ_SORT, 
NP.SORT_PRIKAZ AS NNPRIVEZ_SORT_PRIKAZ, PO.NAZIV AS NNPOMOL_NAZIV, PO.NNLOCATION_ID,
K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK,  
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM BERTH_OWNER BO
LEFT OUTER JOIN BERTH_OWNER_TYPE BOT ON BOT.ID = BO.TYPE
LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = BO.ID_PRIVEZ
LEFT OUTER JOIN NNPOMOL PO ON PO.SIFRA = NP.KATEGORIJA
LEFT OUTER JOIN KUPCI K ON K.ID = BO.ID_LASTNIKA
);

ALTER TABLE TRANSACTION_EXPORT
ADD GENERATE_OPPOSITE_TRANSACTIONS VARCHAR2(1 CHAR);

ALTER TABLE TRANSACTION_EXPORT
ADD ID_CARDS VARCHAR2(3 CHAR);

DROP VIEW V_TRANSACTION_EXPORT;

CREATE OR REPLACE VIEW V_TRANSACTION_EXPORT AS (
  SELECT T.ID_TRANSACTION_EXPORT, T.DESCRIPTION, T.INTERNAL_DESCRIPTION, T.TRANSACTION_TYPE, T.EXPORT_FORMAT, T.EXPORT_FILENAME, T.NNLOCATION_ID, T.USER_IDENTIFICATION_NUMBER, 
  T.TRANSACTION_RECORD_TYPE, T.EXCLUDE_NEGATIVE_TRANSACTIONS, T.EXCLUDE_CUST_POSITIVE_BALANCE, T.OWNER_BANK_ACCOUNT_DD, T.ACTIVE, T.EXPORT_SUBTYPE, T.DEFAULT_EXPORT, T.DATE_FILTER, T.MARK_EXPORTED_OPTION,
  T.GENERATE_OPPOSITE_TRANSACTIONS, T.ID_CARDS,
  TET.DESCRIPTION AS TRANSACTION_TYPE_DESCRIPTION, TEF.DESCRIPTION AS EXPORT_FORMAT_DESCRIPTION
	FROM TRANSACTION_EXPORT T
  LEFT OUTER JOIN TRANSACTION_EXPORT_TYPE TET ON TET.CODE = T.TRANSACTION_TYPE
  LEFT OUTER JOIN TRANSACTION_EXPORT_FORMAT TEF ON TEF.CODE = T.EXPORT_FORMAT
);

DROP VIEW V_NUSER;

CREATE OR REPLACE VIEW V_NUSER AS (
	SELECT N.ID, N.NUSER, N.USER_,N.EMAIL, N.AKT, N.DAVCNA_ST, N.NNLOCATION_ID, N.N_BLAGAJNE, N.COMPUTER_LOCATION,
	NL.OPIS AS LOCATION_OPIS, NL.INTERNI_OPIS AS LOCATION_INTERNI_OPIS, NI.NAZIV AS LOKACI_OPIS, NI.INTERNI_OPIS AS LOKACI_INTERNI_OPIS
	FROM NUSER N
  LEFT OUTER JOIN NNLOCATION NL ON NL.ID = N.CURRENT_NNLOCATION_ID
  LEFT OUTER JOIN NNLOKACI NI ON NI.SIFRA = N.COMPUTER_LOCATION
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1447, SYSDATE, '5.5', 1367, 'Transaction export')
;
