update nrights set komentar = 'Work order reversal',komentar_tuj = 'Work order reversal', interni_opis = 'Work order reversal',description = 'Enables reversal of work orders' 
where pravica = 'STORNO_DN' and komentar ='storno - work order';

DROP VIEW V_POGODBE;

CREATE OR REPLACE VIEW V_POGODBE AS (
	SELECT P.ID_POGODBE AS V_POGODBE_ID, P.ID_POGODBE, P.ID_LASTNIKA, P.ID_PLOVILA, P.ID_MASTER, P.OBJEKT, P.N_PRIVEZA, P.N_POGODBE, P.DATUM_ZACETKA, P.DATUM_KONCA, P.PREDVIDENI_DATUM_KONCA, P.DATUM_KREIRANJA, P.USER_KREIRANJA,
  P.DATUM_SPREMEMBE, P.USER_SPREMEMBE, P.STATUS, P.DATUM_SKLENITVE, P.DATUM_PREKINITVE, P.KOMENTAR, P.TIP_POGODBE, P.EXTENSION_SEQUENCE_NUMBER, P.EXTENSION_DATE, P.ID_PRIVEZ,
  NNSTAT.OPIS AS STATUS_OPIS, NNSTAT.INTERNI_OPIS AS STATUS_INTERNI_OPIS,
  PLOV.IME AS PLOVILA_IME, PLOV.PODALJSA AS PLOVILA_PODALJSA, KUP.IME AS KUPCI_IME, KUP.PRIIMEK AS KUPCI_PRIIMEK, KUP.INT_CODE AS KUPCI_INT_CODE, KUP.VRSTA AS KUPCI_VRSTA,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KUP.IME || ' ' || KUP.PRIIMEK) ELSE (KUP.PRIIMEK || ' ' || KUP.IME) END) AS OWNER,
  NP.ID_PRIVEZ AS NNPRIVEZ_ID_PRIVEZ, NP.KATEGORIJA AS NNPRIVEZ_KATEGORIJA, NP.OBJEKT AS NNPRIVEZ_OBJEKT, NP.N_PRIVEZA AS NNPRIVEZ_PRIVEZ, NP.DOLZINA AS NNPRIVEZ_DOLZINA, 
  NO.OPIS AS NNOBJEKT_OPIS, NO.INTERNI_OPIS AS NNOBJEKT_INTERNI_OPIS, NO.STORAGE AS NNOBJEKT_STORAGE, NNLOC.ID AS NNLOCATION_ID
	FROM M_POGODBE P
	LEFT OUTER JOIN NNSTATPOG NNSTAT ON P.STATUS = NNSTAT.SIFRA
  LEFT OUTER JOIN PLOVILA PLOV ON PLOV.ID = P.ID_PLOVILA
  LEFT OUTER JOIN KUPCI KUP ON KUP.ID = P.ID_LASTNIKA
  LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = P.ID_PRIVEZ
  LEFT OUTER JOIN NNOBJEKT NO ON NO.SIFRA = NP.OBJEKT 
  LEFT OUTER JOIN NNPOMOL NPOM ON NPOM.SIFRA = NP.KATEGORIJA
  LEFT OUTER JOIN NNLOCATION NNLOC ON NNLOC.ID = NPOM.NNLOCATION_ID
);

DROP VIEW V_M_DE_NA;

CREATE OR REPLACE VIEW V_M_DE_NA AS (
SELECT M.ID_DN, M.ID_LASTNIKA, M.ID_PLOVILA, M.ID_ASSET, M.ID_RACUNA, M.ID_PREDRACUN, M.ID_REZERVACIJE, M.ID_POGODBE, M.STEVILKA, M.STATUS, M.ORG_STATUS, M.USER_KREIRANJA, M.USER_SPREMEMBE, M.CONFIRMED, 
M.DATUM_DN, M.TERMIN_DO, M.SKUPAJ, M.SKUPAJ_VAL, M.KOMENTAR, M.LASTNIK_OBVESCEN, M.NNLOCATION_ID, M.ID_OWNER_SIGNATURE, M.TYPE, M.PROFITNI_CENTER, M.DATUM_KREIRANJA, M.DATUM_SPREMEMBE,
M.DESCRIPTION, M.USER_REFERENCE, M.APPROVED_BY, M.APPROVED_ON,
A.NAME AS ASSET_NAME, OFR.STEVILKA AS OFFER_STEVILKA, N.OPIS AS NNSTATDN_OPIS, N.INTERNI_OPIS AS NNSTATDN_INTERNI_OPIS, NS.DESCRIPTION AS NNSTATPON_DESCRIPTION, 
K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, CONCAT(CONCAT(COALESCE(K.PRIIMEK, ''), ' '), COALESCE(K.IME, '')) AS KUPCI_PRIIMEK_IME, K.VALUTA_PLACILA AS KUPCI_VALUTA_PLACILA, 
P.IME AS PLOVILA_IME, L.OPIS AS NNLOCATION_OPIS, L.INTERNI_OPIS AS NNLOCATION_INTERNI_OPIS, 
(SELECT AVG(COALESCE(COMPLETE, 0)) FROM M_STORITVE MS WHERE MS.ID_DN = M.ID_DN) AS SERVICE_COMPLETE_AVERAGE,
(SELECT SUM(COALESCE(S.ZA_PLACILO, 0)) FROM SALDKONT S WHERE S.ID_DN = M.ID_DN AND S.SDK_RN_TIP = 'I' AND S.SDK_RN_PL = 'R') AS SUM_ISSUED_INVOICES,
(SELECT SUM(COALESCE(S.ZA_PLACILO, 0)) FROM SALDKONT S WHERE S.ID_DN = M.ID_DN AND S.SDK_RN_TIP = 'I' AND S.SDK_RN_PL = 'P') AS SUM_ISSUED_PAYMENTS,
(SELECT COUNT(ID) FROM NAJAVE WHERE VRSTA_NAJAVE = 'CRANE' AND ID_DN = M.ID_DN)  AS CRANE_PLAN_COUNT,
(SELECT COUNT(ID_MAINTENANCE_TASK) FROM MAINTENANCE_TASK WHERE ID_DN = M.ID_DN)  AS MAINTENANCE_PLAN_COUNT
FROM M_DE_NA M
LEFT OUTER JOIN M_DE_NA OFR ON OFR.ID_DN = M.ID_PREDRACUN
LEFT OUTER JOIN NNSTATDN N ON N.SIFRA = M.STATUS
LEFT OUTER JOIN NNSTATPON NS ON NS.CODE = M.CONFIRMED
LEFT OUTER JOIN KUPCI K ON K.ID = M.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA P ON P.ID = M.ID_PLOVILA
LEFT OUTER JOIN NNLOCATION L ON L.ID = M.NNLOCATION_ID
LEFT OUTER JOIN ASSET A ON A.ID_ASSET = M.ID_ASSET
);

DROP VIEW V_MONEY;

CREATE OR REPLACE VIEW V_MONEY AS (
  SELECT M.ID_MONEY, M.ID_MENJAVE, M.ID_TIP_TRANS, M.ID_CARDS, M.ZNESEK, M.ZNESEK_SIT, M.STANJE, M.STANJE_VAL, M.NVALUTA, M.TECAJ, M.PAYMENT_RESPONSE_ID, M.ID_KUPCI_CC, M.VRSTA_BL,
  E.DATUM AS EXCHANGE_DATUM, E.CAS AS EXCHANGE_CAS, E.N_BLAGAJNE AS EXCHANGE_N_BLAGAJNE, E.N_IZMENE AS EXCHANGE_N_IZMENE, E.N_TABAKA AS EXCHANGE_N_TABAKA, 
  E.KOMENTAR AS EXCHANGE_KOMENTAR, E.NNLOCATION_ID AS EXCHANGE_NNLOCATION_ID, E.STORNO AS EXCHANGE_STORNO, E.USER_KREIRANJA AS EXCHANGE_USER, 
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (E.IME || ' ' || E.PRIIMEK) ELSE (E.PRIIMEK || ' ' || E.IME) END) AS EXCHANGE_OWNER,
  NC.OPIS AS NNCARDS_OPIS, NC.INTERNI_OPIS AS NNCARDS_INTERNI_OPIS, S.ID_SALDKONT, S.N_RACUNA AS SALDKONT_N_RACUNA, S.VRSTA_RACUNA AS SALDKONT_VRSTA_RACUNA, S.STORNO AS SALDKONT_STORNO, NK.SLO AS NKNJIZBA_OPIS,
  KCC.TEMPORARY AS CREDIT_CARD_TEMPORARY, KCC.ID_CREDIT_CARD_TOKEN AS CREDIT_CARD_TOKEN_ID, TT.OPIS AS TIPI_TRANS_OPIS, TT.INTERNI_OPIS AS TIPI_TRANS_INTERNI_OPIS, NT.OPIS AS NTIPITRANS_OPIS, NT.INTERNI_OPIS AS NTIPITRANS_INTERNI_OPIS
  FROM MONEY M
  LEFT OUTER JOIN NNCARDS NC ON NC.ID_CARDS = M.ID_CARDS 
  LEFT OUTER JOIN EXCHANGE E ON E.ID = M.ID_MENJAVE 
  LEFT OUTER JOIN SALDKONT S ON S.ID_SALDKONT = E.ID_SALDKONT
  LEFT OUTER JOIN NKNJIZBA NK ON NK.SALDKONT = S.VRSTA_RACUNA
  LEFT OUTER JOIN KUPCI_CREDIT_CARDS KCC ON KCC.ID_KUPCI_CC = M.ID_KUPCI_CC
  LEFT OUTER JOIN TIPI_TRANS TT ON TT.ID_TIP_TRANS = M.ID_TIP_TRANS
  LEFT OUTER JOIN NTIPITRANS NT ON NT.IDTRANSDET = E.IDTRANSDET
);

DROP VIEW V_SALDKONT;

CREATE OR REPLACE VIEW V_SALDKONT AS (
	SELECT S.ID_SALDKONT AS SALDKONT_ID_SALDKONT, S.N_RACUNA AS SALDKONT_N_RACUNA, S.DATUM AS SALDKONT_DATUM, S.ZA_PLACILO AS SALDKONT_ZA_PLACILO, S.PORABLJENO AS SALDKONT_PORABLJENO, S.VALUTA_RN AS SALDKONT_VALUTA_RN,
  S.DATUM_VALUTACIJE AS SALDKONT_DATUM_VALUTACIJE, S.VRSTA_RACUNA AS SALDKONT_VRSTA_RACUNA, S.USER_KREIRANJA AS SALDKONT_USER_KREIRANJA, S.DATUM_KREIRANJA AS SALDKONT_DATUM_KREIRANJA,
  S.USER_SPREMEMBE AS SALDKONT_USER_SPREMEMBE, S.DATUM_SPREMEMBE AS SALDKONT_DATUM_SPREMEMBE, S.ID_KUPCA AS SALDKONT_ID_KUPCA, S.ID_PLOVILA AS SALDKONT_ID_PLOVILA, S.ZAPRTO AS SALDKONT_ZAPRTO,
  S.SDK_RN_PL AS SALDKONT_SDK_RN_PL, S.SDK_RN_TIP AS SALDKONT_SDK_RN_TIP, S.LASTNIK_OBVESCEN AS SALDKONT_LASTNIK_OBVESCEN, S.STORNO AS SALDKONT_STORNO, S.KOMENTAR AS SALDKONT_KOMENTAR, S.ID_CARDS AS SALDKONT_ID_CARDS, S.ZNESEK AS SALDKONT_ZNESEK,
  S.PROTIVREDNOST AS SALDKONT_PROTIVREDNOST, CASE WHEN S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) THEN 'Y' ELSE 'N' END AS SALDKONT_DOMESTIC, S.TECAJ_PRERACUN AS SALDKONT_TECAJ_PRERACUN, S.N_KNJIZBE AS SALDKONT_N_KNJIZBE,
  CASE WHEN S.SDK_RN_TIP = 'P' AND EXISTS (SELECT * FROM SALDKONT WHERE ID_SALDKONT = S.ID_SALDKONT_GEN AND SDK_RN_TIP = 'I' AND ZAPRTO = 1) THEN 'Y' ELSE 'N' END AS REC_INV_HAS_CLOSED_ISSUED_INV, 
  S.NCARD AS SALDKONT_NCARD, S.N_LISTINE AS SALDKONT_NLISTINE, S.NNLOCATION_ID AS SALDKONT_NNLOCATION_ID, S.NNFIRMA_ID AS SALDKONT_NNFIRMA_ID, S.ID_DN AS SALDKONT_ID_DN, S.ID_HASH AS SALDKONT_ID_HASH,
  S.PAYMENT_RESPONSE_ID AS SALDKONT_PAYMENT_RESPONSE_ID, S.STATUS AS SALDKONT_STATUS, S.ID_SALDKONT_GEN AS SALDKONT_ID_SALDKONT_GEN, S.ID_EXCHANGE AS SALDKONT_ID_EXCHANGE, S.ID_RACUNA AS SALDKONT_ID_RACUNA, S.ID_FB_ORDER AS SALDKONT_ID_FB_ORDER,
  S.ID_BATCH AS SALDKONT_ID_BATCH, S.DAVEK_NA_STORITVE AS SALDKONT_DAVEK_NA_STORITVE, S.DAVEK_NA_MATERIAL AS SALDKONT_DAVEK_NA_MATERIAL, S.POPUST AS SALDKONT_POPUST, S.DATUM_ORG AS SALDKONT_DATUM_ORG, 
  S.DATUM_PLACILA AS SALDKONT_DATUM_PLACILA, S.VALUTA_PL AS SALDKONT_VALUTA_PL, S.TECAJ_PL AS SALDKONT_TECAJ_PL, S.TECAJ_VALUTE AS SALDKONT_TECAJ_VALUTE, S.STORNONR AS SALDKONT_STORNO_NR, 
  S.BLAGAJNA AS SALDKONT_BLAGAJNA, S.LOKAC AS SALDKONT_LOKAC, S.TRANSACTION_EXPORT_NR AS SALDKONT_TRANSACTION_EXPORT_NR, S.SKLIC AS SALDKONT_SKLIC, S.ZA_PLACILO - S.PORABLJENO AS OUTSTANDING, 
  (CASE WHEN S.SDK_RN_PL = 'R' THEN S.ZA_PLACILO ELSE NULL END) AS INVOICE_AMOUNT,(CASE WHEN S.SDK_RN_PL = 'P' THEN S.ZA_PLACILO ELSE NULL END) AS PAYMENT_AMOUNT, 
  SF.GOVERNMENT_CODE AS SALDKONT_FISC_GOVERNMENT_CODE,
  R.SUBLEASE_OD AS RACUN_DATA_SUBLEASE_OD, R.SUBLEASE_DO AS RACUN_DATA_SUBLEASE_DO, N.OPIS AS M_NNSTOMAR_OPIS, N.KAT AS M_NNSTOMAR_KAT, N.TIMEKAT AS M_NNSTOMAR_TIMEKAT, N.SUBLEASE AS M_NNSTOMAR_SUBLEASE,
  D.ID_PRINT_DOK AS PRINT_DOK_ID_PRINT_DOK, D.STEVILKA AS PRINT_DOK_STEVILKA, D.OPIS AS PRINT_DOK_OPIS, D.DATOTEKA AS PRINT_DOK_DATOTEKA, D.PDF AS PRINT_DOK_PDF, D.OBJAVI AS PRINT_DOK_OBJAVI,
  K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.SALDAKONTI_SIT AS KUPCI_SALDAKONTI_SIT, K.NASLOV AS KUPCI_NASLOV, K.POSTA AS KUPCI_POSTA, K.MESTO AS KUPCI_MESTO, K.DAVCNA_STEVILKA AS KUPCI_DAVCNA_STEVILKA,
  K.SIFRA_DOB AS KUPCI_SIFRA_DOB, K.INT_CODE AS KUPCI_INT_CODE, K.SEND_EMAILS AS KUPCI_SEND_EMAILS, K.N_KK AS KUPCI_N_KK, K.VRSTA AS KUPCI_VRSTA,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
  P.IME AS PLOVILA_IME, KND.OZNAKA AS KUPCI_NDRZAVA_OZNAKA, NC.OPIS AS NNCARDS_OPIS, NC.VRSTA_DENARJA AS NNCARDS_VRSTA_DENARJA, 
  M.ID_PRIVEZ AS M_STORITVE_ID_PRIVEZ, NNP.N_PRIVEZA AS M_STORITVE_NNPRIVEZ_N_PRIVEZA, M.SUBLEASE_PAYMENT AS M_STORITVE_SUBLEASE_PAYMENT, M.KOMENTAR AS M_STORITVE_KOMENTAR, SO.OPIS AS S_OBRACUN_OPIS,
  (CASE WHEN N.OPIS IS NOT NULL THEN N.OPIS ELSE SO.OPIS END) AS ITEM_DESCRIPTION, (CASE WHEN N.INTERNI_OPIS IS NOT NULL THEN N.INTERNI_OPIS ELSE SO.OPIS END) AS ITEM_INTERNAL_DESCRIPTION,
  NKNJ.SLO AS NKNJIZBA_OPIS, NKNJ.INTERNI_OPIS AS NKNJIZBA_INTERNI_OPIS, NKNJ.DEPOSIT AS NKNJIZBA_DEPOSIT, 
  PR.STATUS_CODE AS PAYMENT_RESPONSE_STATUS_CODE, PR.MESSAGE AS PAYMENT_RESPONSE_MESSAGE, PR.INTERNAL_STATUS AS PAYMENT_RESPONSE_INT_STATUS, SE.ID_SALDKONT_EDIT
	FROM SALDKONT S
  LEFT OUTER JOIN SALDKONT_FISC SF ON SF.ID_SALDKONT = S.ID_SALDKONT
  LEFT OUTER JOIN RACUN_DATA R ON R.ID_SALDKONT = S.ID_SALDKONT
  LEFT OUTER JOIN M_STORITVE M ON M.ID_STORITVE = R.ID_STORITVE
  LEFT OUTER JOIN S_OBRACUN SO ON SO.ID_OBRACUN = R.ID_OBRACUN
  LEFT OUTER JOIN M_NNSTOMAR N ON N.SIFRA = M.STORITEV
  LEFT OUTER JOIN PRINT_DOK D ON D.MODUL = S.VRSTA_RACUNA AND D.REFERENCA = S.ID_SALDKONT
  LEFT OUTER JOIN KUPCI K ON K.ID = S.ID_KUPCA
  LEFT OUTER JOIN PLOVILA P ON P.ID = S.ID_PLOVILA
  LEFT OUTER JOIN NNCARDS NC ON NC.ID_CARDS = S.ID_CARDS
  LEFT OUTER JOIN NNDRZAVE KND ON KND.SIFRA = K.NDRZAVA
  LEFT OUTER JOIN NNPRIVEZ NNP ON NNP.ID_PRIVEZ = M.ID_PRIVEZ
  LEFT OUTER JOIN NKNJIZBA NKNJ ON NKNJ.SALDKONT = S.VRSTA_RACUNA
  LEFT OUTER JOIN PAYMENT_RESPONSE PR ON PR.ID = S.PAYMENT_RESPONSE_ID
  LEFT OUTER JOIN SALDKONT_EDIT SE ON SE.ID_SALDKONT = S.ID_SALDKONT AND SE.ACT='Y'
  WHERE R.ZAP_ST IS NULL OR R.ZAP_ST = 1
);


DROP VIEW V_RACUN_DATA;

CREATE OR REPLACE VIEW V_RACUN_DATA AS (
  SELECT R.ID_RACUN_DATA, R.N_RACUNA, R.KOLICINA, R.ZN_DAVKA, R.CENABD, R.ZNESEK, R.ID_OBRACUN, R.ID_STORITVE, R.ID_SALDKONT, R.ZAP_ST, R.POPUST, R.DAV_STOPNJA, R.STORNO, 
  R.ST_DN, R.RN_TEKST, R.AVT_FAKT, R.NETO, R.NON_REFUND, R.TIP, R.ID_STORITVE_GEN, R.DEPOSIT_AMOUNT, R.DATUM_OD, R.DATUM_DO, R.KOMENTAR, 
  S.ZNESEK AS SALDKONT_ZNESEK, S.ID_KUPCA AS SALDKONT_ID_KUPCA, S.ID_PLOVILA AS SALDKONT_ID_PLOVILA, S.TECAJ_VALUTE AS SALDKONT_TECAJ_VALUTE,S.TECAJ_PRERACUN AS SALDKONT_TECAJ_PRERACUN, 
  S.VALUTA_RN AS SALDKONT_VALUTA_RN, S.STOAK AS SALDKONT_STOAK, NK.SLO AS KNJIZBA_OPIS,
  SO.OPIS AS OBRACUN_OPIS, SE.NAZIV AS OBRACUN_ENOTA_NAZIV, M.NCARD AS STORITVE_NCARD, N.OPIS AS NNSTOMAR_OPIS, N.INTERNI_OPIS AS NNSTOMAR_INTERNI_OPIS, 
  N.TRIGGER_DEPOSIT AS NNSTOMAR_TRIGGER_DEPOSIT, NE.OPIS AS NNSTOMAR_ENOTA_OPIS,
  (CASE WHEN SO.OPIS IS NOT NULL THEN SO.OPIS ELSE (CASE WHEN N.OPIS IS NOT NULL THEN N.OPIS ELSE NK.SLO END) END) AS TITLE,
  (CASE WHEN SO.OPIS IS NOT NULL THEN SO.OPIS ELSE (CASE WHEN N.INTERNI_OPIS IS NOT NULL THEN N.INTERNI_OPIS ELSE NK.INTERNI_OPIS END) END) AS INTERNAL_TITLE
	FROM RACUN_DATA R
  LEFT OUTER JOIN SALDKONT S ON S.ID_SALDKONT = R.ID_SALDKONT
  LEFT OUTER JOIN NKNJIZBA NK ON NK.SALDKONT = S.VRSTA_RACUNA
  LEFT OUTER JOIN S_OBRACUN SO ON SO.ID_OBRACUN = R.ID_OBRACUN
  LEFT OUTER JOIN S_ENOTE SE ON SE.ID_ENOTA = SO.ID_ENOTA
  LEFT OUTER JOIN M_STORITVE M ON M.ID_STORITVE = R.ID_STORITVE
  LEFT OUTER JOIN M_NNSTOMAR N ON N.SIFRA = M.STORITEV
  LEFT OUTER JOIN NNENOTE NE ON NE.SIFRA = ENOTA
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1664, SYSDATE, '5.5', 1584, 'Internal description')
;