DROP VIEW V_KUPCI;

CREATE OR REPLACE VIEW V_KUPCI AS (
	SELECT K.ID, K.ID_MEMBER, K.IME, K.PRIIMEK, K.MESTO, K.NASLOV, K.POSTA, K.TELEFON_1, K.TELEFON_2, K.EMAIL, K.YACHT_CLUB_ID, K.TELEX, K.VRSTA, K.NDRZAVA, K.DATUM_SPREMEMBE, K.DATUM_KREIRANJA, K.ID_STATE, K.STATE, K.DATUM_ROJSTVA,
	K.SALDAKONTI_SIT, K.SALDAKONTI_DEM, K.SALDAKONTI_KOM, K.BELEZKA, K.MANAGER, K.ACT, K.KODA_JEZIKA, K.CODE_REFERRAL, K.LOYALTY, K.LOYALTY_CODE, K.DAVCNA_STEVILKA, K.SEND_TEXT, K.ID_EXTERNAL, K.DATE_EXTERNAL, K.UNSUBSCRIBED, K.NTITLE, K.VEHICLE_REGISTRATION_NUM,
  ENQ.INITIAL_CONTACT_DATE, ENQ.SELL_PHASE, ENQ.BOAT_LOCATION_ID, ENQ.SELL_PHASE_STATUS AS SELL_PHASE_STATUS, ENQ.BOAT_LENGTH_ID AS ENQUIRY_BOAT_LENGTH_ID,
	NNTIT.INTERNI_OPIS AS NNTITLE_DESC, NNDRZ.OPIS AS NNDRZAVA_OPIS, NNDRZ.INTERNI_OPIS AS NNDRZAVA_DESC, NNDOK.INTERNI_OPIS AS VRSTA_DOKUMENTA_DESC, NNVRS.OPIS AS VRSTA_OPIS, NNVRS.INTERNI_OPIS AS VRSTA_DESC, NNVRSLOY.OPIS AS LOYALTY_TYPE_DESCRIPTION,
	NNDRZDR.INTERNI_OPIS AS DRZAVA_ROJSTVA_DESC, NNDRZCI.INTERNI_OPIS AS CITIZENSHIP_DESC, NNMAR.INTERNI_OPIS AS MARITAL_STATUS_DESC, NNUSR.USER_ AS MANAGER_USER,
  NSP.OPIS AS SELL_PHASE_OPIS, NNLB.OPIS AS BOAT_LOCATION_OPIS,
  (SELECT LISTAGG(NV.OPIS,', ') WITHIN GROUP(ORDER BY NV.OPIS ASC) TYPES FROM KUPCI_VRSTA KV, NNVRSKUP NV WHERE NV.SIFRA = KV.VRSTA AND KV.ID_KUPCA = K.ID) AS TYPES_DESCRIPTIONS,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
  ENQ.CONVERSION_DATE, K.START_YC_MEMBERSHIP, LAST_DATE.LAST_CONTACT_DATE
	FROM KUPCI K
	LEFT OUTER JOIN NNTITLE NNTIT ON K.NTITLE = NNTIT.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZ ON K.NDRZAVA = NNDRZ.SIFRA
	LEFT OUTER JOIN NNDOKUME NNDOK ON K.VRSTA_DOKUMENTA = NNDOK.SIFRA
	LEFT OUTER JOIN NNVRSKUP NNVRS ON K.VRSTA = NNVRS.SIFRA
  LEFT OUTER JOIN NNVRSKUP NNVRSLOY ON K.LOYALTY_CODE = NNVRSLOY.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZDR ON K.DRZAVA_ROJSTVA = NNDRZDR.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZCI ON K.CITIZENSHIP = NNDRZCI.SIFRA
	LEFT OUTER JOIN NNMARSTAT NNMAR ON K.MARITAL_STATUS = NNMAR.SIFRA
  LEFT OUTER JOIN NUSER NNUSR ON K.MANAGER = NNUSR.NUSER
  LEFT OUTER JOIN ENQUIRY ENQ ON K.ID = ENQ.ID_KUPCA
  LEFT OUTER JOIN NNSELL_PHASE NSP ON ENQ.SELL_PHASE = NSP.SIFRA
  LEFT OUTER JOIN NNLOCATION NNLB ON ENQ.BOAT_LOCATION_ID = NNLB.ID
  LEFT OUTER JOIN (SELECT ID_KUPCA, MAX(LAST_DATE) AS LAST_CONTACT_DATE FROM 
(select IDKUPCA AS ID_KUPCA, TRUNC(MAX(DATUMKREIRANJA)) AS LAST_DATE FROM KUPCIBELEZKE WHERE VELJAVNA='Y' AND (select vrednost from S_NASTAVITVE WHERE NAZIV='OwnerLastContactDateFromNotes')=1 group by IDKUPCA
union
select KA1.ID_KUPCA, TRUNC(MAX(AK1.DATE_FROM)) AS LAST_DATE FROM KUPCI_ACTIVITY KA1 JOIN ACTIVITY AK1 ON KA1.ID_ACTIVITY=AK1.ID_ACTIVITY WHERE AK1.STATUS='N' AND (select vrednost from S_NASTAVITVE WHERE NAZIV='OwnerLastContactDateFromActivities')=1 group by KA1.ID_KUPCA
union
select O1.ID AS ID_KUPCA, TRUNC(MAX(E1.DATUM_POSILJANJA)) AS LAST_DATE FROM OPOMINI O1 JOIN EMAILS E1 ON E1.ID_EMAIL = O1.ID_EMAIL WHERE (O1.NPISMO = (SELECT N1.NPISMO FROM NPISMO N1 WHERE N1.NPISMO_TYPE = 'EMAIL')) AND E1.STATUS=2 AND (select vrednost from S_NASTAVITVE WHERE NAZIV='OwnerLastContactDateFromEmails')=1 group by O1.ID
union
select O2.ID AS ID_KUPCA, TRUNC(MAX(S2.DATE_CREATED)) AS LAST_DATE FROM OPOMINI O2 JOIN SMS S2 ON S2.ID = O2.ID_SMS WHERE (O2.NPISMO = 'S') AND (select vrednost from S_NASTAVITVE WHERE NAZIV='OwnerLastContactDateFromSms')=1 group by O2.ID
) LCD GROUP BY LCD.ID_KUPCA) LAST_DATE ON LAST_DATE.ID_KUPCA=K.ID
)
;

DROP VIEW V_PLOVILA;

CREATE OR REPLACE VIEW V_PLOVILA AS (
SELECT P.ID, P.ID_LASTNIKA, P.N_POGODBE, P.FEKALNI_TANK, P.NTIP, P.IME, P.MATICNA_LUKA, P.REGISTRSKA_N, P.NZASTAVA, P.DOLZINA, P.SIRINA, P.VISINA, P.TEZA, P.GREZ, P.PODSTAVEK, P.VALUTA, P.VREDNOST,
P.PROIZVAJALEC, P.LETO_IZDELAVE, P.KONSTRUKCIJSKI_MATERIAL, P.TIP_MOTORJA, P.MOC_MOTORJA, P.ENOTA_MOCI_MOTORJA, P.STEVILO_MOTORJEV, P.N_MOTORJA_1, P.N_MOTORJA_2, P.N_MOTORJA_3, P.ZAVAROVALNICA,
P.N_ZAVAROVALNE_POLICE, P.ZAVAROVANO_DO, P.ZAVAROVALNA_VSOTA, P.VALUTA_ZAVAROVALNE_VSOTE, P.BELEZKA, P.BELEZKA_2, P.POGODBA_OD, P.POGODBA_DO,P.TRENUTNO_OD, P.TRENUTNO_DO, P.PLOVNO_DOVOLJENJE, 
P.KRAJ_PLOVNEGA_DOVOLJENJA, P.DATUM_PLOVNEGA_DOVOLJENJA, P.N_DELOVNEGA_NALOGA, P.STORITVE,
P.USER_KREIRANJA, P.DATUM_KREIRANJA, P.USER_SPREMEMBE, P.DATUM_SPREMEMBE, P.N_ZIMOVANJE, P.DATUM_PREK_ZIMOVANJA, P.BOOKING, P.STEVILO_KABIN, P.MODEL, P.STEVILO_LEZISC, P.GORIVO, P.MOC_MOTORJA_1,
P.MOC_MOTORJA_2, P.ID_TIPA_MOTORJA_1, P.ID_TIPA_MOTORJA_2, P.ID_TIPA_MOTORJA_3, P.ENOTA_MOCI_MOTORJA_1, P.ENOTA_MOCI_MOTORJA_2, P.ENOTA_MOCI_MOTORJA_3, P.ID_PROIZVAJALCA, P.ID_KONSTR_MAT,
P.ID_PODSTAVKA, P.ID_TIPA, P.TIP_PLOVILA, P.DAT_PLOV_DOV, P.DATUM_ZAVAROVANJE, P.POOBLASTILO_DO, P.VPIS_LIST_DO, P.DATUM_MENJ_OLJA, P.DATUM_RED_SERVIS, P.ST_UR_MOTORJA, P.PROVIZIJA_DELITEV,
P.KASKO_ZAVAROVANJE_DO, P.PROVIZIJA, P.OCISCENA, P.RFID, P.PODALJSA, P.DOVOLJENJE, P.LASTNISTVO, P.ID_PLOVILA_CARINA, P.ACT, P.PLOVILA_IZVOR, P.RFIDSIGNAL, P.LAST_PORT, P.COLOR, P.ID_PRIVEZ, 
P.PROPULSION_TYPE, P.PAYMENT_TYPE, P.UNDERWATER_HULL, P.TOP_SIDES, P.DECK, P.SUPER_STRUCTURE, P.SURFACE, P.HULL_ID_NUMBER, P.VRSKUP, P.KUPCI_CREDIT_CARD_ID, P.BOAT_PRICE, P.BRUTO_TEZA, 
P.ST_POTNIKOV, P.LOADING_WEIGHT, P.LOADING_VOLUME, P.CHARTER_NNLOCATION_ID, P.FUEL_TYPE, P.REG_EXPIRE_DATE, P.TRAILER_REGISTRATION_NUM, P.INSURANCE_POLICY_NAME,
NT.OPIS AS NNTIP_OPIS, NT.INTERNI_OPIS AS NNTIP_INTERNI_OPIS, ND.OPIS AS NNDRZAVE_OPIS, ND.INTERNI_OPIS AS NNDRZAVE_INTERNI_OPIS, NVK.OPIS AS NNVRSKUP_OPIS, NVK.INTERNI_OPIS AS NNVRSKUP_INTERNI_OPIS,
NNL.OPIS AS NNLEZISCA_OPIS, NFT.OPIS AS FUEL_TYPE_OPIS, NMO.OPIS AS MODEL_OPIS, BERTH_TEMP.ID_PRIVEZ AS TRENUTNI_ID_PRIVEZA,
CASE WHEN BERTH_TEMP.ID_PRIVEZ IS NOT NULL THEN BERTH_TEMP.OBJEKT ELSE P.TRENUTNI_OBJEKT_PRIVEZA END AS TRENUTNI_OBJEKT_PRIVEZA,
CASE WHEN BERTH_TEMP.ID_PRIVEZ IS NOT NULL THEN BERTH_TEMP.N_PRIVEZA ELSE P.TRENUTNA_N_PRIVEZA END AS TRENUTNA_N_PRIVEZA,
CASE WHEN BERTH_CONTRACT.ID_PRIVEZ IS NOT NULL THEN BERTH_CONTRACT.OBJEKT ELSE P.POGODBENI_OBJEKT_PRIVEZA END AS POGODBENI_OBJEKT_PRIVEZA,
CASE WHEN BERTH_CONTRACT.ID_PRIVEZ IS NOT NULL THEN BERTH_CONTRACT.N_PRIVEZA ELSE P.POGODBENA_N_PRIVEZA END AS POGODBENA_N_PRIVEZA,
CASE WHEN (P.TRENUTNI_OBJEKT_PRIVEZA IS NOT NULL AND P.TRENUTNA_N_PRIVEZA IS NOT NULL AND UPPER(P.TRENUTNA_N_PRIVEZA) <> (SELECT UPPER(VREDNOST) FROM S_NASTAVITVE WHERE NAZIV = 'StartIzhod')) THEN 'Y' ELSE 'N' END AS IN_MARINA,
CASE WHEN (UPPER(P.TRENUTNA_N_PRIVEZA) = (SELECT UPPER(VREDNOST) FROM S_NASTAVITVE WHERE NAZIV = 'StartIzhod')) THEN 'Y' ELSE 'N' END AS ON_TEMPORARY_EXIT
FROM PLOVILA P
LEFT OUTER JOIN NNTIP NT ON NT.SIFRA = P.NTIP
LEFT OUTER JOIN NNDRZAVE ND ON ND.SIFRA = P.NZASTAVA
LEFT OUTER JOIN NNVRSKUP NVK ON NVK.SIFRA = P.VRSKUP
LEFT OUTER JOIN NNLEZISCA NNL ON NNL.SIFRA = P.STEVILO_LEZISC
LEFT OUTER JOIN NNFUEL_TYPE NFT ON NFT.SIFRA = P.FUEL_TYPE
LEFT OUTER JOIN NNMODEL NMO ON NMO.SIFRA = P.MODEL
LEFT OUTER JOIN (SELECT PRIVEZI.*, RANK() OVER (PARTITION BY ID_PLOVILA ORDER BY ID_PRIVEZI ASC) RNK FROM PRIVEZI WHERE ID_POGODBE IS NULL) PRIVEZI_TEMP ON (PRIVEZI_TEMP.ID_PLOVILA = P.ID AND PRIVEZI_TEMP.RNK = 1)
LEFT OUTER JOIN NNPRIVEZ BERTH_TEMP ON BERTH_TEMP.ID_PRIVEZ = PRIVEZI_TEMP.ID_PRIVEZ
LEFT OUTER JOIN (SELECT PRIVEZI.*, RANK() OVER (PARTITION BY ID_PLOVILA ORDER BY ID_PRIVEZI DESC) RNK FROM PRIVEZI WHERE ID_POGODBE IS NOT NULL) PRIVEZI_CONTRACT ON (PRIVEZI_CONTRACT.ID_PLOVILA = P.ID AND PRIVEZI_CONTRACT.RNK = 1)
LEFT OUTER JOIN NNPRIVEZ BERTH_CONTRACT ON BERTH_CONTRACT.ID_PRIVEZ = PRIVEZI_CONTRACT.ID_PRIVEZ
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2150, SYSDATE, '5.5', 2070, 'VKupci in VPlovila')
;
